上机算法刷题暑期篇(一) —— AcWing 3692. 最长连续公共子序列(西电)

题目链接

AcWing 3692. 最长连续公共子序列

题目详情

题目解析

我们一看到题目,最长和连续子串,我们第一反应应该是什么?没错,就是dp,一般来说,子串问题常见的解法有两种:

  • 双指针

  • dp

    这道题无疑就是一道最常见的dp问题,而dp问题最重要的无疑就是状态转移了,而在这道题中,我们假设s1字符串的i位置与s2字符串的j位置匹配成功,我们这时就可以有两种选择:

  • 将这个匹配结果纳入总结果中,即为:
    d p i j = d p i − 1 j − 1 + 1 dpij=dpi-1j-1+1 dpij=dpi−1j−1+1

  • 不采用这个结果,即为:
    d p i j = d i − 1 j dpij=di-1j dpij=di−1j

所以最后的状态转换方程为:
d p i j = m a x ( d p i − 1 j − 1 + 1 , d p i − 1 j ) dpij = max(dpi - 1j - 1 + 1, dpi-1j) dpij=max(dpi−1j−1+1,dpi−1j)

同时,如果dp[i][j]>res,我们就要更新res,同时由于i为外层循环,所以i的位置就是子字符串最后一位字母的位置,所以我们能得到最后的代码:

cpp 复制代码
#include<iostream>
#include<cstring>

using namespace std;

const int N = 110;
int dp[N][N];
char a[N],b[N];

int main()
{
	memset(dp, 0, sizeof(dp));
	int res = 0;
	int index=0; //记录最长公共子串的起始位置
	string resstr;
	scanf("%s %s",a+1,b+1);
    int l1=strlen(a+1),l2=strlen(b+1);
	for (int i = 1; i <=l1; i++)
		for (int j = 1; j <= l2; j++)
		{
			if (a[i] == b[j])
			{
				dp[i][j] = max(dp[i - 1][j - 1] + 1, dp[i-1][j]);
			}
			if (dp[i][j]>=res)
			{
				res = dp[i][j];
				index = i - res + 1;
			}
		}
	for (int i = index; i < index + res; i++)
	{
		resstr += a[i];
	}
	cout << res << endl << resstr;
	return 0;
}

拓展;go语言的解题代码

go 复制代码
package main

import (
	"fmt"
	"math"
)

const N = 110

func countEnglishLetters(data []byte) int {
	count := 0
	for _, b := range data {
		if (b >= 'A' && b <= 'Z') || (b >= 'a' && b <= 'z') {
			count++
		}
	}
	return count
}

func main() {
	dp := make([][]int, N)
	for i := range dp {
		dp[i] = make([]int, N)
	}

	// 预留足够的空间
	a := make([]byte, N)
	b := make([]byte, N)

	var aRaw, bRaw string
	_, _ = fmt.Scan(&aRaw, &bRaw) // 读取输入的字符串

	copy(a[1:], []byte(aRaw)) // 复制到 a 的第1个位置开始
	copy(b[1:], []byte(bRaw)) // 复制到 b 的第1个位置开始
	
	l1:=countEnglishLetters(a)+1
	l2:=countEnglishLetters(b)+1
	
	res := 0
	index := 0 // 记录最长公共子串的起始位置
	var resStr string

	for i := 1; i <= l1; i++ {
		for j := 1; j <= l2; j++ {
			if a[i] == b[j] {
				dp[i][j] = int(math.Max(float64(dp[i-1][j-1])+1, float64(dp[i-1][j])))
			} 
			if dp[i][j] >= res {
				res = dp[i][j]
				index = i - res +1
			}
		}
	}
	for i := index; i < index+res; i++ {
		resStr += string(a[i])
	}
	
	fmt.Println(res)
	fmt.Println(resStr)
}
相关推荐
·present·17 分钟前
CSAPP(lecture 3)
c++
别动我齐刘海42 分钟前
机器人 C++ / 系统联调补强2——异常处理、Protobuf
linux·c++·人工智能·学习·算法·机器学习·机器人
basketball6161 小时前
C++ 中字符串与常见类型的转换总结
开发语言·c++
荆棘鸟智能1 小时前
短历时洪水预报算法实践:水文模型与 LightGBM 残差订正融合
人工智能·算法·机器人
等我调个Bug1 小时前
C++智能指针通俗讲解
开发语言·c++
葫三生2 小时前
关于三生原理系列被技术开发社区批量收录或引发策展边界讨论的一种思考
大数据·人工智能·深度学习·算法·机器学习·数据挖掘·开源
catcatuncle2 小时前
OpenWorkBuddy 部署排错手册:从源码启动到自己搭一个给团队用,七个最容易卡住的地方
算法
avi91112 小时前
【AI教人】在Inspector显示所有Delegate-Odin Inspector之三
java·前端·算法·delegate·inspector·editor扩展·unity editor
淡海水2 小时前
06-02-源码-增量标记算法实现
算法·unity·c#·gc
碧海银沙音频科技研究院2 小时前
实现炬芯ATS308X的usb cdc 串口IAP 固件升级功能实现
人工智能·嵌入式硬件·深度学习·算法